package cn.estsh.i3plus.pojo.wms.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Description : 库位
 * @Reference :
 * @Author : alwaysfrin
 * @CreateDate : 2018-09-04 15:58
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@Table(name="WH_STOCK_LOC")
@Api("仓库库位")
public class StockLocation extends BaseBean {

    @Column(name="LOC_CODE")
    @ApiParam("仓库库位代码")
    public String locCode;

    @Column(name="LOC_NAME")
    @ApiParam("仓库库位名称")
    public String locName;

    @Column(name="AREA_ID")
    @ApiParam(value = "库区编号", example = "-1")
    @JsonSerialize(using = ToStringSerializer.class)
    public Long areaId;

    @Column(name="AREA_CODE_RDD")
    @ApiParam("库区代码")
    public String areaCodeRdd;

    @Column(name="AREA_NAME_RDD")
    @ApiParam("库区名称")
    public String areaNameRdd;

    public Long getAreaId() {
        if(areaId != null) {
            return areaId.longValue();
        }else{
            return areaId;
        }
    }
}
