package cn.estsh.i3plus.pojo.wms.sqlpack;

import cn.estsh.i3plus.pojo.base.tool.HqlPack;
import cn.estsh.i3plus.pojo.wms.bean.*;
import cn.estsh.i3plus.pojo.wms.bean.InterfaceDevice;
import cn.estsh.i3plus.pojo.wms.bean.WareHouse;
import cn.estsh.i3plus.pojo.wms.bean.WmsTrans;
import cn.estsh.i3plus.pojo.wms.bean.WmsTransType;

/**
 * @Description : 仓库管理对象封装
 * @Reference :
 * @Author : silliter.yuan
 * @CreateDate : 2018-10-31 10:45
 * @Modify:
 **/
public class WmsHqlPack {

    /**
     * 工厂仓库模糊分页查询
     * @param wareHouse
     * @return
     */
    public static String packHqlFactoryStore(WareHouse wareHouse) {
        StringBuffer result = new StringBuffer();

        // 部门名称
        HqlPack.getStringLikerPack(wareHouse.getCode(),"code", result);
        // 部门代码
        HqlPack.getStringLikerPack(wareHouse.getName(),"name", result);

        return result.toString();
    }

    public static String packHqlWmsButton(WmsButton wmsButton) {
        StringBuffer result = new StringBuffer();

        // 功能名称（name）
        HqlPack.getStringLikerPack(wmsButton.getName(),"name", result);
        // 前端实现（ui）
        HqlPack.getStringLikerPack(wmsButton.getUi(),"ui", result);
        // URI权限规则（bs）
        HqlPack.getStringLikerPack(wmsButton.getBs(),"bs", result);

        return result.toString();
    }

    /**
     *  接口驱动类信息 分页查询
     * @return
     */
    public static String packHqlInterfaceDevice(InterfaceDevice interfaceDevice){
        StringBuffer sb = new StringBuffer();
        //驱动类名称
        HqlPack.getStringEqualPack(interfaceDevice.getDeviceClassName(),"deviceClassName",sb);

        return null;
    }

    /**
     * 元数据信息 分页查询
     * @param wmsObject
     * @return
     */
    public static String packHqlWmsObject(WmsObject wmsObject){
        StringBuffer result = new StringBuffer();

        // 编码
        HqlPack.getStringLikerPack(wmsObject.getCode(),"code",result);
       // 名称
        HqlPack.getStringEqualPack(wmsObject.getName(),"name",result);
        // 数据主表
        HqlPack.getStringEqualPack(wmsObject.getTableName(),"tableName",result);
        // 自定义业务拦截
        HqlPack.getStringEqualPack(wmsObject.getBizIntercept(),"bizIntercept",result);

        return result.toString();
    }

    /**
     * 元数据字段分页查询
     * @param wmsField
     * @return
     */
    public static String packHqlWmsField(WmsField wmsField){
        StringBuffer result = new StringBuffer();
        // 编码
        HqlPack.getStringLikerPack(wmsField.getObjectCode(),"objectCode",result);
        HqlPack.getStringLikerPack(wmsField.getTableName(),"tableName",result);
        return result.toString();
    }


    /**
     * 交易类型信息 分页查询
     * @param wmsTransType
     * @return
     */
    public static String packHqlWmsTransType(WmsTransType wmsTransType) {
        StringBuffer result = new StringBuffer();

        //查询参数封装
        HqlPack.getStringLikerPack(wmsTransType.getTransCode(),"transCode",result);
        HqlPack.getStringLikerPack(wmsTransType.getTransName(),"transName",result);

        return result.toString();
    }

    /**
     * 库存交易记录信息 分页查询
     * @param wmsTrans
     * @return
     */
    public static String packHqlWmsTrans(WmsTrans wmsTrans) {
        StringBuffer result = new StringBuffer();

        //查询参数封装
        HqlPack.getStringEqualPack(wmsTrans.getTransCode(),"transCode",result);
        HqlPack.getNumEqualPack(wmsTrans.getSn(),"sn",result);
        HqlPack.timeBuilder(wmsTrans.getCreateDatetime(),null,"createDatetime",result,true);

        return result.toString();
    }
}
